// H bridge

// Left H bridge
#define TRANSISTOR_A    9 // Left P-Channel
#define TRANSISTOR_B   10 // Left N-Channel
#define TRANSISTOR_C    7 // Right P-Channel
#define TRANSISTOR_D   11 // Right N-Channel

#define CURRENT_L      A0 // Left current sensor

// Right H bridge
#define TRANSISTOR_E    6 // Left P-Channel
#define TRANSISTOR_F    8 // Left N-Channel
#define TRANSISTOR_G    5 // Right P-Channel
#define TRANSISTOR_H    4 // Right N-Channel

#define CURRENT_R      A1 // Left current sensor

#define CURRENT_ADJUST A4 // Potentiometer current adjustment

#define SHOOT_THROUGH_PAUSE  50

#define STEP_DELAY_ON   100
#define STEP_DELAY_OFF 950
#define STEP_LOOP_NO   100

byte read_byte = 0;
byte step_state = 0;
int demo_mode = 0;
int i;



void establishContact() {
  // Wait until a first byte is received from serial port
  while (Serial.available() <= 0) {
    Serial.print('A');   // send a capital A
    delay(300);
  }
}

void setup() {
  // initialize Pins
  pinMode(TRANSISTOR_A, OUTPUT);
  digitalWrite(TRANSISTOR_A, 0);
  pinMode(TRANSISTOR_B, OUTPUT);
  digitalWrite(TRANSISTOR_B, 0);
  pinMode(TRANSISTOR_C, OUTPUT);
  digitalWrite(TRANSISTOR_C, 0);
  pinMode(TRANSISTOR_D, OUTPUT);
  digitalWrite(TRANSISTOR_D, 0);

  pinMode(TRANSISTOR_E, OUTPUT);
  digitalWrite(TRANSISTOR_E, 0);
  pinMode(TRANSISTOR_F, OUTPUT);
  digitalWrite(TRANSISTOR_F, 0);
  pinMode(TRANSISTOR_G, OUTPUT);
  digitalWrite(TRANSISTOR_G, 0);
  pinMode(TRANSISTOR_H, OUTPUT);
  digitalWrite(TRANSISTOR_H, 0);

  pinMode(CURRENT_L, INPUT);
  pinMode(CURRENT_R, INPUT);
  pinMode(CURRENT_ADJUST, INPUT);

  // start serial port at 115200 bps:
  Serial.begin(115200);
  //establishContact();


  read_byte = 0;
  demo_mode = 2;
  step_state = 0;

}

void loop() {

  if (Serial.available() > 0) {
    // get incoming byte:
    read_byte = Serial.read();

    if(read_byte == 'A'){
      digitalWrite(TRANSISTOR_B, 0);
      delayMicroseconds(SHOOT_THROUGH_PAUSE);
      digitalWrite(TRANSISTOR_A, 1);
    }
    if(read_byte == 'a'){
      digitalWrite(TRANSISTOR_A, 0);
    }

    if(read_byte == 'B'){
      digitalWrite(TRANSISTOR_A, 0);
      delayMicroseconds(SHOOT_THROUGH_PAUSE);
      digitalWrite(TRANSISTOR_B, 1);
    }
    if(read_byte == 'b'){
      digitalWrite(TRANSISTOR_B, 0);
    }

    if(read_byte == 'C'){
      digitalWrite(TRANSISTOR_D, 0);
      delayMicroseconds(SHOOT_THROUGH_PAUSE);
      digitalWrite(TRANSISTOR_C, 1);
    }
    if(read_byte == 'c'){
      digitalWrite(TRANSISTOR_C, 0);
    }

    if(read_byte == 'D'){
      digitalWrite(TRANSISTOR_C, 0);
      delayMicroseconds(SHOOT_THROUGH_PAUSE);
      digitalWrite(TRANSISTOR_D, 1);
    }
    if(read_byte == 'd'){
      digitalWrite(TRANSISTOR_D, 0);
    }

    if(read_byte == 'E'){
      digitalWrite(TRANSISTOR_F, 0);
      delayMicroseconds(SHOOT_THROUGH_PAUSE);
      digitalWrite(TRANSISTOR_E, 1);
    }
    if(read_byte == 'e'){
      digitalWrite(TRANSISTOR_E, 0);
    }

    if(read_byte == 'F'){
      digitalWrite(TRANSISTOR_E, 0);
      delayMicroseconds(SHOOT_THROUGH_PAUSE);
      digitalWrite(TRANSISTOR_F, 1);
    }
    if(read_byte == 'f'){
      digitalWrite(TRANSISTOR_F, 0);
    }

    if(read_byte == 'G'){
      digitalWrite(TRANSISTOR_H, 0);
      delayMicroseconds(SHOOT_THROUGH_PAUSE);
      digitalWrite(TRANSISTOR_G, 1);
    }
    if(read_byte == 'g'){
      digitalWrite(TRANSISTOR_G, 0);
    }

    if(read_byte == 'H'){
      digitalWrite(TRANSISTOR_G, 0);
      delayMicroseconds(SHOOT_THROUGH_PAUSE);
      digitalWrite(TRANSISTOR_H, 1);
    }
    if(read_byte == 'h'){
      digitalWrite(TRANSISTOR_H, 0);
    }

    if(read_byte == '0'){
      demo_mode = 0;
      digitalWrite(TRANSISTOR_A, 0);
      digitalWrite(TRANSISTOR_B, 0);
      digitalWrite(TRANSISTOR_C, 0);
      digitalWrite(TRANSISTOR_D, 0);
      digitalWrite(TRANSISTOR_E, 0);
      digitalWrite(TRANSISTOR_F, 0);
      digitalWrite(TRANSISTOR_G, 0);
      digitalWrite(TRANSISTOR_H, 0);      
    }

    if(read_byte == '1'){
      demo_mode = 1;
      digitalWrite(TRANSISTOR_A, 0);
      digitalWrite(TRANSISTOR_B, 0);
      digitalWrite(TRANSISTOR_C, 0);
      digitalWrite(TRANSISTOR_D, 0);
      digitalWrite(TRANSISTOR_E, 0);
      digitalWrite(TRANSISTOR_F, 0);
      digitalWrite(TRANSISTOR_G, 0);
      digitalWrite(TRANSISTOR_H, 0);      
      delayMicroseconds(SHOOT_THROUGH_PAUSE);
    }

    if(read_byte == '2'){
      demo_mode = 2;
      digitalWrite(TRANSISTOR_A, 0);
      digitalWrite(TRANSISTOR_B, 0);
      digitalWrite(TRANSISTOR_C, 0);
      digitalWrite(TRANSISTOR_D, 0);
      digitalWrite(TRANSISTOR_E, 0);
      digitalWrite(TRANSISTOR_F, 0);
      digitalWrite(TRANSISTOR_G, 0);
      digitalWrite(TRANSISTOR_H, 0);      
      delayMicroseconds(SHOOT_THROUGH_PAUSE);
    }

    read_byte = 0;
  }


  if(demo_mode == 2){// Two DC motors
     digitalWrite(TRANSISTOR_A, 1);
     delayMicroseconds(SHOOT_THROUGH_PAUSE);
     digitalWrite(TRANSISTOR_D, 1);
     delayMicroseconds(SHOOT_THROUGH_PAUSE);
     delay(3000);

     digitalWrite(TRANSISTOR_A, 0);
     delayMicroseconds(SHOOT_THROUGH_PAUSE);
     digitalWrite(TRANSISTOR_D, 0);
     delayMicroseconds(SHOOT_THROUGH_PAUSE);
     
     digitalWrite(TRANSISTOR_E, 1);
     delayMicroseconds(SHOOT_THROUGH_PAUSE);
     digitalWrite(TRANSISTOR_H, 1);
     delayMicroseconds(SHOOT_THROUGH_PAUSE);
     delay(3000);

     digitalWrite(TRANSISTOR_E, 0);
     delayMicroseconds(SHOOT_THROUGH_PAUSE);
     digitalWrite(TRANSISTOR_H, 0);
     delayMicroseconds(SHOOT_THROUGH_PAUSE);

     digitalWrite(TRANSISTOR_B, 1);
     delayMicroseconds(SHOOT_THROUGH_PAUSE);
     digitalWrite(TRANSISTOR_C, 1);
     delay(3000);

     digitalWrite(TRANSISTOR_B, 0);
     delayMicroseconds(SHOOT_THROUGH_PAUSE);
     digitalWrite(TRANSISTOR_C, 0);
     delayMicroseconds(SHOOT_THROUGH_PAUSE);

     digitalWrite(TRANSISTOR_F, 1);
     delayMicroseconds(SHOOT_THROUGH_PAUSE);
     digitalWrite(TRANSISTOR_G, 1);
     delay(3000);

     digitalWrite(TRANSISTOR_F, 0);
     delayMicroseconds(SHOOT_THROUGH_PAUSE);
     digitalWrite(TRANSISTOR_G, 0);
}


  if(demo_mode == 1){// Stepper motor

    digitalWrite(TRANSISTOR_A, 1);
    for(i=0; i < STEP_LOOP_NO; i++){
      digitalWrite(TRANSISTOR_D, 1);
      delayMicroseconds(STEP_DELAY_ON);
      digitalWrite(TRANSISTOR_D, 0);
      delayMicroseconds(STEP_DELAY_OFF);
    }
    digitalWrite(TRANSISTOR_A, 0);

      
    digitalWrite(TRANSISTOR_E, 1);
    for(i=0; i < STEP_LOOP_NO; i++){
      digitalWrite(TRANSISTOR_H, 1);
      delayMicroseconds(STEP_DELAY_ON);
      digitalWrite(TRANSISTOR_H, 0);
      delayMicroseconds(STEP_DELAY_OFF);
    }
    digitalWrite(TRANSISTOR_E, 0);
      
    digitalWrite(TRANSISTOR_C, 1);
    for(i=0; i < STEP_LOOP_NO; i++){
      digitalWrite(TRANSISTOR_B, 1);
      delayMicroseconds(STEP_DELAY_ON);
      digitalWrite(TRANSISTOR_B, 0);
      delayMicroseconds(STEP_DELAY_OFF);
    }
    digitalWrite(TRANSISTOR_C, 0);

    digitalWrite(TRANSISTOR_G, 1);
    for(i=0; i < STEP_LOOP_NO; i++){
      digitalWrite(TRANSISTOR_F, 1);
      delayMicroseconds(STEP_DELAY_ON);
      digitalWrite(TRANSISTOR_F, 0);
      delayMicroseconds(STEP_DELAY_OFF);
    }
    digitalWrite(TRANSISTOR_G, 0);


  }

}
